var Route = function(stage, options) {
  this.stage = stage;
  this.options = options || {};  
};

var tempPathRecord = [];


Route.prototype.draw = function(mapmetadata,pathRecord) {  
    try {
      this.graphics = new createjs.Graphics();
      this.graphics.setStrokeStyle(1);
      this.graphics.beginStroke("green");
      var firstPoseX =(pathRecord.poses[0].pose.position.x - mapmetadata.origin.position.x) / mapmetadata.resolution;
      var firstPoseY = mapmetadata.height - (pathRecord.poses[0].pose.position.y - mapmetadata.origin.position.y) /mapmetadata.resolution;
      this.graphics.moveTo(firstPoseX, firstPoseY);
      for (let c = 1; c < pathRecord.poses.length; ++c) {
        var targetPoseX = (pathRecord.poses[c].pose.position.x - mapmetadata.origin.position.x) / mapmetadata.resolution;
        var targetPoseY = mapmetadata.height - (pathRecord.poses[c].pose.position.y - mapmetadata.origin.position.y) / mapmetadata.resolution;
        this.graphics.lineTo(targetPoseX, targetPoseY);
      }
      this.stage.removeAllChildren();
      this.stage.addChild(new createjs.Shape(this.graphics));
    } catch(e) {
      console.log(e);
    }
};